# Configure Cluster Properties

> For the complete documentation index, see [llms.txt](https://docs.redpanda.com/llms.txt). Component-specific: [cloud-data-platform-full.txt](https://docs.redpanda.com/cloud-data-platform-full.txt)

---
title: Configure Cluster Properties
latest-operator-version: v26.1.4
latest-console-tag: v3.7.3
latest-connect-version: 4.93.0
latest-redpanda-tag: v26.1.9
docname: cluster-maintenance/config-cluster
page-component-name: cloud-data-platform
page-version: master
page-component-version: master
page-component-title: Cloud
page-relative-src-path: cluster-maintenance/config-cluster.adoc
page-edit-url: https://github.com/redpanda-data/cloud-docs/edit/main/modules/manage/pages/cluster-maintenance/config-cluster.adoc
description: Learn how to configure cluster properties to enable and manage features.
page-git-created-date: "2025-04-08"
page-git-modified-date: "2025-08-27"
---

<!-- Source: https://docs.redpanda.com/cloud-data-platform/manage/cluster-maintenance/config-cluster.md -->

Cluster configuration properties are set to their default values and are automatically replicated across all brokers. You can use cluster properties to enable and manage features such as [Iceberg topics](https://docs.redpanda.com/cloud-data-platform/manage/iceberg/about-iceberg-topics/), [data transforms](https://docs.redpanda.com/cloud-data-platform/develop/data-transforms/), and [audit logging](https://docs.redpanda.com/cloud-data-platform/manage/audit-logging/).

For a complete list of the cluster properties available in Redpanda Cloud, see [Cluster Configuration Properties](https://docs.redpanda.com/cloud-data-platform/reference/properties/cluster-properties/) and [Object Storage Properties](https://docs.redpanda.com/cloud-data-platform/reference/properties/object-storage-properties/).

> 📝 **NOTE**
>
> Some properties are read-only and cannot be changed. For example, `cluster_id` is a read-only property that is automatically set when the cluster is created.

## [](#prerequisites)Prerequisites

-   **`rpk` version 25.1.2+**: To check your current version, see [Install or Update rpk](https://docs.redpanda.com/cloud-data-platform/manage/rpk/rpk-install/).

-   **Redpanda version 25.1.2+**: You can find the version on your cluster’s Overview page in the Redpanda Cloud UI.

    To verify that you’re logged into the Redpanda control plane and have the correct `rpk` profile configured for your target cluster, run `rpk cloud login` and select your cluster.


## [](#limitations)Limitations

Cluster properties are supported on BYOC and Dedicated clusters running on AWS and GCP.

-   They are not available on BYOC and Dedicated clusters running on Azure.

-   They are not available on Serverless clusters.


## [](#set-cluster-configuration-properties)Set cluster configuration properties

You can set cluster configuration properties using the `rpk` command-line tool or the Cloud API.

### rpk

Use `rpk cluster config` to set cluster properties.

For example, to enable audit logging, set [`audit_enabled`](https://docs.redpanda.com/cloud-data-platform/reference/properties/cluster-properties/#audit_enabled) to `true`:

```bash
rpk cluster config set audit_enabled true
```

To set a cluster property with a secret, you must use the following notation:

```bash
rpk cluster config set iceberg_rest_catalog_client_secret '${secrets.<secret-name>}'
```

> 📝 **NOTE**
>
> Some properties require a rolling restart, and it can take several minutes for the update to complete. The `rpk cluster config set` command returns the operation ID.

### Cloud API

Use the Cloud API to set cluster properties:

-   Create a cluster by making a [`POST /v1/clusters`](https://docs.redpanda.com/api/doc/cloud-controlplane/operation/operation-clusterservice_createcluster) request. Edit `cluster_configuration` in the request body with a key-value pair for `custom_properties`.

-   Update a cluster by making a [`PATCH /v1/clusters/{cluster.id}`](https://docs.redpanda.com/api/doc/cloud-controlplane/operation/operation-clusterservice_updatecluster) request, passing the cluster ID as a parameter. Include the properties to update in the request body.


For example, to set [`audit_enabled`](https://docs.redpanda.com/cloud-data-platform/reference/properties/cluster-properties/#audit_enabled) to `true`:

```bash
# Store your cluster ID in a variable.
export RP_CLUSTER_ID=<cluster-id>

# Retrieve a Redpanda Cloud access token.
export RP_CLOUD_TOKEN=`curl -X POST "https://auth.prd.cloud.redpanda.com/oauth/token" \
    -H "content-type: application/x-www-form-urlencoded" \
    -d "grant_type=client_credentials" \
    -d "client_id=<client-id>" \
    -d "client_secret=<client-secret>"`

# Update your cluster configuration to enable audit logging.
curl -H "Authorization: Bearer ${RP_CLOUD_TOKEN}" -X PATCH \
  "https://api.cloud.redpanda.com/v1/clusters/${RP_CLUSTER_ID}" \
 -H 'accept: application/json'\
 -H 'content-type: application/json' \
 -d '{"cluster_configuration":{"custom_properties": {"audit_enabled":true}}}'
```

The [`PATCH /clusters/{cluster.id}`](https://docs.redpanda.com/api/doc/cloud-controlplane/operation/operation-clusterservice_updatecluster) request returns the ID of a long-running operation. You can check the status of the operation by polling the [`GET /operations/{id}`](https://docs.redpanda.com/api/doc/cloud-controlplane/operation/operation-operationservice_getoperation) endpoint.

To set a cluster property with a secret, you must use the following notation with the secret name:

```bash
curl -H "Authorization: Bearer <token>" -X PATCH \
"https://api.cloud.redpanda.com/v1/clusters/<cluster-id>" \
  -H 'accept: application/json'\
  -H 'content-type: application/json' \
  -d '{"cluster_configuration": {
        "custom_properties": {
            "iceberg_rest_catalog_client_secret": "${secrets.<secret-name>}"
            }
        }
    }'
```

> 📝 **NOTE**
>
> Some properties require a rolling restart for the update to take effect. This triggers a [long-running operation](https://docs.redpanda.com/cloud-data-platform/manage/api/cloud-byoc-controlplane-api/#lro) that can take several minutes to complete.

## [](#view-cluster-property-values)View cluster property values

You can see the value of a cluster configuration property using `rpk` or the Cloud API.

### rpk

Use `rpk cluster config get` to view the current cluster property value.

For example, to view the current value of [`audit_enabled`](https://docs.redpanda.com/cloud-data-platform/reference/properties/cluster-properties/#audit_enabled), run:

```bash
rpk cluster config get audit_enabled
```

### Cloud API

Use the Cloud API to get the current configuration property values for a cluster.

Make a [`GET /clusters/{cluster.id}`](https://docs.redpanda.com/api/doc/cloud-controlplane/operation/operation-clusterservice_getcluster) request, passing the cluster ID as a parameter. The response body contains the current `computed_properties` values. For example, to get the current value of [`audit_enabled`](https://docs.redpanda.com/cloud-data-platform/reference/properties/cluster-properties/#audit_enabled):

```bash
# Store your cluster ID in a variable.
export RP_CLUSTER_ID=<cluster-id>

# Retrieve a Redpanda Cloud access token.
export RP_CLOUD_TOKEN=`curl -X POST "https://auth.prd.cloud.redpanda.com/oauth/token" \
    -H "content-type: application/x-www-form-urlencoded" \
    -d "grant_type=client_credentials" \
    -d "client_id=<client-id>" \
    -d "client_secret=<client-secret>"`

# Get your cluster configuration property values.
curl -H "Authorization: Bearer ${RP_CLOUD_TOKEN}" -X GET \
  "https://api.cloud.redpanda.com/v1/clusters/${RP_CLUSTER_ID}" \
 -H 'accept: application/json'\
 -H 'content-type: application/json' \
```

## [](#suggested-reading)Suggested reading

-   [Introduction to rpk](https://docs.redpanda.com/cloud-data-platform/manage/rpk/intro-to-rpk/)

-   [Redpanda Cloud API Overview](https://docs.redpanda.com/api/doc/cloud-controlplane/topic/topic-cloud-api-overview)

-   [Redpanda Cloud API Quickstart](https://docs.redpanda.com/api/doc/cloud-controlplane/topic/topic-quickstart)